using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.FcBusinesses.Products;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses
{
    public interface IFcProductSummaryRepository
    {
        Task<BaseResult> Add(FcProductSummaryElastic FcProductSummary);

        Task<BaseResult> AddManyAsync(IEnumerable<FcProductSummaryElastic> FcProductSummarys);

        Task<BulkResponse> DeleteMany(IEnumerable<FcProductSummaryElastic> FcProductSummarys);

        Task<DeleteByQueryResponse> DeleteByIds(IEnumerable<long> ids);

        Task<SmartTableResult<FcProductSummaryElastic>> SearchForExcel(BoolQueryDescriptor<FcProductSummaryElastic> query);

        Task<SmartTableResult<FcProductSummaryElastic>> GetByIds(List<long> ids);

        Task<SmartTableResult<FcProductSummaryElastic>> Search(BoolQueryDescriptor<FcProductSummaryElastic> query, int count);
    }

    public class FcProductSummaryRepository : IFcProductSummaryRepository
    {
        private readonly ElasticIndex<FcProductSummaryElastic> _dbContext;

        public FcProductSummaryRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<FcProductSummaryElastic>(settings.Value.ClusterUrl, "fcproductsummary");
        }

        #region search

        public async Task<SmartTableResult<FcProductSummaryElastic>> SearchForExcel(BoolQueryDescriptor<FcProductSummaryElastic> query)
        {
            return await _dbContext.Search(query);
        }

        public async Task<SmartTableResult<FcProductSummaryElastic>> Search(BoolQueryDescriptor<FcProductSummaryElastic> query, int count)
        {
            return await _dbContext.Search(query, count);
        }

        #endregion search

        #region Add order

        public async Task<BaseResult> Add(FcProductSummaryElastic FcProductSummary)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(FcProductSummary);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }

        public async Task<BaseResult> AddManyAsync(IEnumerable<FcProductSummaryElastic> FcProductSummarys)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(FcProductSummarys);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<BulkResponse> DeleteMany(IEnumerable<FcProductSummaryElastic> FcProductSummarys)
        {
            return await _dbContext.DeleteMany(FcProductSummarys);
        }

        public async Task<DeleteByQueryResponse> DeleteByIds(IEnumerable<long> ids)
        {
            return await _dbContext.DeleteByIds(ids);
        }

        public async Task<SmartTableResult<FcProductSummaryElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<FcProductSummaryElastic>();
            var idsQ = new QueryContainerDescriptor<FcProductSummaryElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }

        #endregion Add order
    }
}